/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#ifndef __CYBLE_MTK_H__
#define __CYBLE_MTK_H__

#include <project.h>
#include "UART_Compatibility.h"
#include "MTK_CI.h"


#define _1000_US                                        1000    // in us
#define UNIT_PACKET_TX_TIMEOUT                          625     // 1 packet (in us)
#define DEFAULT_DTM_TX_END_DELAY                        625     // 1000 packets (in ms)
#define DTM_TX_START_DELAY                              10      // in ms
#define DEFAULT_MTK_PACKET_LENGTH                       0x25
#define DEFAULT_MTK_PACKET_TYPE                         0x00

#ifndef pmu_mode_transition_reg    
    #define pmu_mode_transition_reg 0x1e02
    #define clk_clk_en_reg 0x0804
#endif    
#ifndef _BIT0
    #define _BIT0  0
#endif
    
extern void     MTK_init(void);
extern void     ProcessMTKCommands(void);
extern void     set_packet_length(uint32_t length);
extern uint32_t get_packet_length(void);
extern void     set_packet_type(uint32_t type);
extern uint32_t get_packet_type(void);
extern void     DTM_tx_start(uint32_t channel, int8 power, int32_t num_packets);
extern void     DTM_rx_start(uint32_t channel);
extern void     stop_DTM_tests(void);


enum calmask
{
    MODEGAIN_CAL_MASK=1,
    DCOC_CAL_MASK,
    FDPOUT_CAL_MASK = 4,
    FD_CAL_MASK = 8
};


void PrintRSSI(uint32 temp);
void Start_Adv_Emulation();
void DTM_tx_adv_trig(uint8 channel, uint16 adv_interval);
void UART_print_hex(uint32 input);
#endif  // __CYBLE_MTK_H__
/* [] END OF FILE */
