#include "UART_Compatibility.h"

cy_stc_sysint_t mtkInt =
{
    MTK_ISR_NUMBER,
    MTK_ISR_PRIORITY, 
};

cy_stc_sysint_t twiInt =
{
    UART_2_Wire_ISR_NUMBER,
    UART_2_Wire_ISR_PRIORITY, 
};

void MTK_SetCustomInterruptHandler(void (*func)(void))
{
    Cy_SysInt_Init(&mtkInt, func);
} 

void UART_2_Wire_SetCustomInterruptHandler(void (*func)(void))
{
    Cy_SysInt_Init(&twiInt, func);
} 

void MTK_UartPutString(char string[])
{
	Cy_SCB_UART_PutString(MTK_HW, string);
}

void UART_2_Wire_UartPutString(char string[])
{
	Cy_SCB_UART_PutString(UART_2_Wire_HW, string);
}

uint32_t MTK_UartGetChar(void)
{
	return Cy_SCB_UART_Get(MTK_HW);
}

uint32_t UART_2_Wire_UartGetChar(void)
{
	return Cy_SCB_UART_Get(UART_2_Wire_HW);

}

uint32_t MTK_UartPutChar(uint32_t data)
{
	return Cy_SCB_UART_Put(MTK_HW,data);
}

uint32_t UART_2_Wire_UartPutChar(uint32_t data)
{
	return Cy_SCB_UART_Put(UART_2_Wire_HW,data);
}

uint32 UART_2_Wire_SpiUartReadRxData(void)
{
    uint32 rxData = 0u;
    rxData = UART_2_Wire_HW->RX_FIFO_RD;
    return (rxData);
}

void UART_2_Wire_SpiUartWriteTxData(uint32 txData)
{
    /* Wait until TX FIFO has space to put data element */
    while (UART_2_Wire_SPI_UART_FIFO_SIZE == UART_2_Wire_GET_TX_FIFO_ENTRIES)
    {
    }

    UART_2_Wire_HW->TX_FIFO_WR = txData;
}
void   UART_2_Wire_SpiUartPutArray(const uint8 wrBuf[], uint32 count)
{
            uint32 i;

        for (i=0u; i < count; i++)
        {
            UART_2_Wire_SpiUartWriteTxData((uint32) wrBuf[i]);
        }
}

/* [] END OF FILE */
