#include <project.h>

//Including the missing #defines from the cydevicetrm.h
#define MTK_INTR_RX_TRIGGER_POS        (0u)   /* [0]  Trigger on RX FIFO entires            */
#define MTK_INTR_RX_NOT_EMPTY_POS      (2u)   /* [2]  RX FIFO is not empty                  */
#define MTK_INTR_RX_FULL_POS           (3u)   /* [3]  RX FIFO is full                       */
#define MTK_INTR_RX_OVERFLOW_POS       (5u)   /* [5]  Attempt to write to a full RX FIFO    */
#define MTK_INTR_RX_UNDERFLOW_POS      (6u)   /* [6]  Attempt to read from an empty RX FIFO */
#define MTK_INTR_RX_BLOCKED_POS        (7u)   /* [7]  No access to the EZ memory            */
#define MTK_INTR_RX_FRAME_ERROR_POS    (8u)   /* [8]  Frame error in received data frame    */
#define MTK_INTR_RX_PARITY_ERROR_POS   (9u)   /* [9]  Parity error in received data frame   */
#define MTK_INTR_RX_BAUD_DETECT_POS    (10u)  /* [10] LIN baud rate detection is completed   */
#define MTK_INTR_RX_BREAK_DETECT_POS   (11u)  /* [11] Break detection is successful         */
#define MTK_INTR_RX_TRIGGER            ((uint32) 0x01u)
#define MTK_INTR_RX_FIFO_LEVEL         (MTK_INTR_RX_TRIGGER)
#define MTK_INTR_RX_NOT_EMPTY          ((uint32) 0x01u << MTK_INTR_RX_NOT_EMPTY_POS)
#define MTK_INTR_RX_FULL               ((uint32) 0x01u << MTK_INTR_RX_FULL_POS)
#define MTK_INTR_RX_OVERFLOW           ((uint32) 0x01u << MTK_INTR_RX_OVERFLOW_POS)
#define MTK_INTR_RX_UNDERFLOW          ((uint32) 0x01u << MTK_INTR_RX_UNDERFLOW_POS)
#define MTK_INTR_RX_BLOCKED            ((uint32) 0x01u << MTK_INTR_RX_BLOCKED_POS)
#define MTK_INTR_RX_FRAME_ERROR        ((uint32) 0x01u << MTK_INTR_RX_FRAME_ERROR_POS)
#define MTK_INTR_RX_PARITY_ERROR       ((uint32) 0x01u << MTK_INTR_RX_PARITY_ERROR_POS)
#define MTK_INTR_RX_BAUD_DETECT        ((uint32) 0x01u << MTK_INTR_RX_BAUD_DETECT_POS)
#define MTK_INTR_RX_BREAK_DETECT       ((uint32) 0x01u << MTK_INTR_RX_BREAK_DETECT_POS)
#define MTK_ISR_NUMBER                 MTK_SCB_IRQ__INTC_NUMBER
#define MTK_ISR_PRIORITY               ((uint8) MTK_SCB_IRQ__INTC_CORTEXM4_PRIORITY)

#define UART_2_Wire_INTR_RX_TRIGGER_POS        (0u)   /* [0]  Trigger on RX FIFO entires            */
#define UART_2_Wire_INTR_RX_NOT_EMPTY_POS      (2u)   /* [2]  RX FIFO is not empty                  */
#define UART_2_Wire_INTR_RX_FULL_POS           (3u)   /* [3]  RX FIFO is full                       */
#define UART_2_Wire_INTR_RX_OVERFLOW_POS       (5u)   /* [5]  Attempt to write to a full RX FIFO    */
#define UART_2_Wire_INTR_RX_UNDERFLOW_POS      (6u)   /* [6]  Attempt to read from an empty RX FIFO */
#define UART_2_Wire_INTR_RX_BLOCKED_POS        (7u)   /* [7]  No access to the EZ memory            */
#define UART_2_Wire_INTR_RX_FRAME_ERROR_POS    (8u)   /* [8]  Frame error in received data frame    */
#define UART_2_Wire_INTR_RX_PARITY_ERROR_POS   (9u)   /* [9]  Parity error in received data frame   */
#define UART_2_Wire_INTR_RX_BAUD_DETECT_POS    (10u)  /* [10] LIN baud rate detection is completed   */
#define UART_2_Wire_INTR_RX_BREAK_DETECT_POS   (11u)  /* [11] Break detection is successful         */
#define UART_2_Wire_INTR_RX_TRIGGER            ((uint32) 0x01u)
#define UART_2_Wire_INTR_RX_FIFO_LEVEL         (UART_2_Wire_INTR_RX_TRIGGER)
#define UART_2_Wire_INTR_RX_NOT_EMPTY          ((uint32) 0x01u << UART_2_Wire_INTR_RX_NOT_EMPTY_POS)
#define UART_2_Wire_INTR_RX_FULL               ((uint32) 0x01u << UART_2_Wire_INTR_RX_FULL_POS)
#define UART_2_Wire_INTR_RX_OVERFLOW           ((uint32) 0x01u << UART_2_Wire_INTR_RX_OVERFLOW_POS)
#define UART_2_Wire_INTR_RX_UNDERFLOW          ((uint32) 0x01u << UART_2_Wire_INTR_RX_UNDERFLOW_POS)
#define UART_2_Wire_INTR_RX_BLOCKED            ((uint32) 0x01u << UART_2_Wire_INTR_RX_BLOCKED_POS)
#define UART_2_Wire_INTR_RX_FRAME_ERROR        ((uint32) 0x01u << UART_2_Wire_INTR_RX_FRAME_ERROR_POS)
#define UART_2_Wire_INTR_RX_PARITY_ERROR       ((uint32) 0x01u << UART_2_Wire_INTR_RX_PARITY_ERROR_POS)
#define UART_2_Wire_INTR_RX_BAUD_DETECT        ((uint32) 0x01u << UART_2_Wire_INTR_RX_BAUD_DETECT_POS)
#define UART_2_Wire_INTR_RX_BREAK_DETECT       ((uint32) 0x01u << UART_2_Wire_INTR_RX_BREAK_DETECT_POS)
#define UART_2_Wire_ISR_NUMBER                  UART_2_Wire_SCB_IRQ__INTC_NUMBER
#define UART_2_Wire_ISR_PRIORITY               ((uint8) UART_2_Wire_SCB_IRQ__INTC_CORTEXM4_PRIORITY)
#define UART_2_Wire_FIFO_SIZE                  (8u)  /* TX or RX FIFO size. */
#define UART_2_Wire_UART_BYTE_MODE_ENABLE      (1u)
#define UART_2_Wire_SPI_UART_FIFO_SIZE         UART_2_Wire_GET_FIFO_SIZE(UART_2_Wire_UART_BYTE_MODE_ENABLE)
#define UART_2_Wire_TX_FIFO_STATUS_USED_POS    (0u)  /* [3:0]   Amount of entries in TX FIFO */
#define UART_2_Wire_TX_FIFO_SR_VALID_POS       (15u) /* [15]    Shifter status of TX FIFO    */
#define UART_2_Wire_TX_FIFO_STATUS_RD_PTR_POS  (16u) /* [18:16] TX FIFO read pointer         */
#define UART_2_Wire_TX_FIFO_STATUS_WR_PTR_POS  (24u) /* [26:24] TX FIFO write pointer        */
#define UART_2_Wire_FF_DATA_NR_LOG2_PLUS1_MASK (0x1Fu) /* Number of bits to represent #bytes in FIFO. */
#define UART_2_Wire_TX_FIFO_STATUS_USED_MASK   ((uint32) UART_2_Wire_FF_DATA_NR_LOG2_PLUS1_MASK)

//Some 1 line functions

#define MTK_INTR_RX_REG               (MTK_HW->INTR_RX)
#define MTK_CLEAR_INTR_RX(sourceMask)      \
                                            do{     \
                                                MTK_INTR_RX_REG     = (uint32) (sourceMask); \
                                            }while(0)
#define MTK_ClearRxInterruptSource(interruptMask)  MTK_CLEAR_INTR_RX(interruptMask)
                       
#define UART_2_Wire_INTR_RX_MASKED_REG         (UART_2_Wire_HW->INTR_RX_MASKED)
#define UART_2_Wire_INTR_RX_REG               (UART_2_Wire_HW->INTR_RX)
#define UART_2_Wire_INTR_RX_REG               (UART_2_Wire_HW->INTR_RX)
#define UART_2_Wire_CLEAR_INTR_RX(sourceMask)      \
                                                    do{     \
                                                        UART_2_Wire_INTR_RX_REG     = (uint32) (sourceMask); \
                                                      }while(0)
#define UART_2_Wire_ClearRxInterruptSource(interruptMask)  UART_2_Wire_CLEAR_INTR_RX(interruptMask)
#define UART_2_Wire_CHECK_INTR_RX_MASKED(sourceMask)       (0u != (UART_2_Wire_INTR_RX_MASKED_REG     & \
                                                                       (sourceMask)))

/* Return FIFO size depends on UART_2_Wire_CTRL_BYTE_MODE bit */
#define UART_2_Wire_GET_FIFO_SIZE(condition) ((0u != (condition)) ? \
                                                    (2u * UART_2_Wire_FIFO_SIZE) : (UART_2_Wire_FIFO_SIZE))

#define UART_2_Wire_GET_TX_FIFO_ENTRIES    (UART_2_Wire_HW->TX_FIFO_STATUS & UART_2_Wire_TX_FIFO_STATUS_USED_MASK)

                                                    
void MTK_SetCustomInterruptHandler(void (*func)(void));
void UART_2_Wire_SetCustomInterruptHandler(void (*func)(void));
void MTK_UartPutString(char string[]);
void UART_2_Wire_UartPutString(char string[]);
uint32_t MTK_UartGetChar(void);
uint32_t UART_2_Wire_UartGetChar(void);
uint32_t MTK_UartPutChar(uint32_t data);
uint32_t UART_2_Wire_UartPutChar(uint32_t data);
uint32 UART_2_Wire_SpiUartReadRxData(void);
void UART_2_Wire_SpiUartWriteTxData(uint32 txData);
void   UART_2_Wire_SpiUartPutArray(const uint8 wrBuf[], uint32 count);
//uint32_t UART_2_Wire_SpiUartPutArray(void *txBuf, uint32_t size);
/* [] END OF FILE */
