/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#ifndef _BLE_HAL_H_
#define _BLE_HAL_H_

#include "project.h"
#include "cydevice_trm.h"
#include "reg_access.h"
 
  
/** SIMO BUCK options **/

typedef enum eDTM_test_modes
{
    DTM_TRANSMIT,
    DTM_RECEIVE,
    DTM_STOP
}eDTMTestModes;


typedef enum eData_rates
{
    ONE_MBPS,
    TWO_MBPS
}eDataRates;

typedef enum eTxRx_test_modes
{
    TXRX_NORMAL,
    TXRX_TRANSMIT_CONTINUOUS,
    TXRX_RECEIVE_CONTINUOUS
}eTXRXModes;

//uint16 cal_val_4,cal_val_0,cal_val_m6,cal_val_m12,cal_val_m16,cal_val_m20;

typedef enum eTransmitPowers
{
  TX_4DBM,
  TX_0DBM,
  TX_MINUS_6DBM,
  TX_MINUS_12DBM,
  TX_MINUS_16DBM,
  TX_MINUS_20DBM,
  TX_INVALID
}eTxPower;

void CyBleHal_RadioInit(void);

void CyBleHal_RCBInit(uint8 div);

void CyBleHal_LinkLayerInit(void);

void CyBleHal_RadioInitWithNoLinkLayerConfig(void);

uint8_t CyBleHal_IsRadioInitialized(void);

void CyBleHal_Disable_RCB_Access(void);

void CyBleHal_Enable_RCB_Access(void);

uint16 CyBleHal_RCBRead(uint16 addr);

uint16 CyBle_RcbRegRead(uint16 addr);

void CyBleHal_RCBWrite(uint16 addr, uint16 val);

void CyBle_RcbRegWrite(uint16 addr, uint16 val);

uint8 CyBleHal_SetPayloadPattern(uint8 u8Pattern);

uint8 CyBleHal_SetChannel(uint8 u8Channel);

uint8 CyBleHal_SetDTMMode(uint8 u8Mode);

void CyBleHal_SetDataLength(uint8 u8length);

uint8 CyBleHal_SetDataRate(uint8 u8Rate);

uint8 CyBleHal_SetTXRXModes(uint8 u8Modes);

eTxPower ll_hal_translate_power(int8 power);

uint8 CyBleHal_SetTxPower (eTxPower u8Power);

void CyBleHal_Set_PA_GainSetting(uint16 gainlsb, uint16 gainmsb, uint8 adv_conn);

void CyBleHal_Get_LL_PA_GainSetting(uint16 *gainlsb, uint16 *gainmsb );

void CyBleHal_DynamicCompensation(uint8 Channel);

void CyBle_Timed_Receive(uint16 u16Time_ms );

void CyBle_Timed_Transmit(uint16 u16Time_ms );

void CyBleHal_ConfigureDDFT(uint8_t mux_cfg_1, uint8_t mux_cfg_2);

uint8_t CyBleHal_ReadBlessState(void);

uint8_t CyBleHal_ReadBleMTState(void);

void CyBleHal_EnableEcoInDSM(void);

void CyBleHal_DisableEcoInDSM(void);

uint8_t CyBleHal_IsEcoEnabledInDSM(void);

void CyBleHal_SetDsmExitConfig(uint8_t cfg);

void CyBleHal_SetDeepsleepExited(uint8_t val);

void CyBleHal_EnterLPM(void);

void CyBleHal_ExitExtendedDSM(void);

void CyBleHal_ExitLPM(void);

uint8_t CyBleHal_IsInDSM(void);

void CyBleHal_DtmTxConfigure(void);

void CyBleHal_DtmRxConfigure(void);

void CyBleHal_EnableInterrupt(void);

void CyBleHal_DisableInterrupt(void);

void CyBleHal_ExecuteCommand(uint8_t command);


void CyBleHal_EnableBist(void);

void CyBleHal_DisableBist(void);

void CyBleHal_ResetBless(void);

void CyBleHal_ResetLL(void);

void CyBleHal_DisableLLClock(void);

void CyBleHal_BlessClearAllInterrupt(void);

void CyBleHal_BlessDisableAllInterrupt(void);

void CyBleHal_BlessEnableInterrupt(uint32_t mask);

void CyBleHal_BlessDisableInterrupt(uint32_t mask);

void CyBleHal_BlellClearAllInterrupt(void);

void CyBleHal_BlellDisableAllInterrupt(void);

void CyBleHal_BlellEnableInterrupt(uint32_t mask);

void CyBleHal_BlellDisableInterrupt(uint32_t mask);

void CyBleHal_EnableAdft(uint32_t adft0, uint32_t adft1);

void CyBleHal_GetAdvScanRespData(uint8_t *buf, uint8_t size);

void CyBleHal_GetConnPacket(uint8_t *buf, uint8_t size);

int16 convert_rssi(uint16 u16gain, uint16 u16rssi);

void CyBleHal_EnterLPMWithAutoWakeup(void);

void CyBleHal_SingleCPU_RCBWrite(uint16 addr, uint16 data);

uint16 CyBleHal_SingleCPU_RCBRead(uint16 addr);

void CyBleHal_Enable_Single_CPU_ReadWrite_in_TXRX(void);

int16 convert_rssi(uint16 u16gain, uint16 u16rssi);

int16 CyBleHal_GetRSSIfromRadio(void);

int16 CyBleHal_GetRSSIfromLinkLayer(void);

int16 CyBleHal_GetRSSIfromRegval(uint16 u16rssi);

void ll_hal_transmit_carrier_wave(uint8 channel);

void ll_hal_dtm_tx_test( uint8 length, uint8 payload_type, uint8 channel);

void ll_hal_tx_modulated(uint8 channel, uint8 payload_type);

void ll_hal_dtm_rx_test(uint8 channel);

uint16 ll_hal_stop_dtm();

void ll_hal_set_captrim(uint16 captrim);

void Disable_WDT(void);

void Enable_Low_Voltage_Flash_Mode(void);

void SwitchToULPBuckConfig(uint32 setVal,uint16 delay);

void CyBleHal_SetLdoOut(int8 power);

void CyBle_SetRadioVoltage(eTxPower power);

void eco_ddft_enable(void);

void RCB_FIFOWrite(uint16 addr, uint16 val);

uint16 RCBRead_RXData();

void RCBInitiateRead(uint16 addr);

void RCBWrite(uint16 addr, uint16 val);

void CyBleHal_DisableInterrupt();

void CyBleHal_EnableInterrupt();
   

 #endif // _BLE_HAL_H_

/* [] END OF FILE */
