/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"
#include "ble_hal.h"
#include <TwoWire.h>
#include <MTK_CI.h>
#include <RegulatoryTest.h>
#include <CyBLE_MTK.h>
#include <stdio.h>
#define VDDRHVL_TRIM
void betacyModeGainInit(uint32 manual_enable, uint32 freq);

int main(void)
{ 

    Enable_Low_Voltage_Flash_Mode();//To enable VDDD = 1.8 V
    Disable_WDT();
    __enable_irq();
    CY_SET_REG32(0x40267f10, 0x000007DE); //0x000007DE);       //Fixes 2 BUCK2 ripple 0000H_00-00_0111_11-01_1110
    TwoWireInit();
    MTK_init();
    RegulatoryTestInit();

#ifdef VDDRHVL_TRIM
    CY_SET_REG32(0x403DFF04, 0x00000007);
    CY_SET_REG32(0x403DFF0C, 0x0000001F);
#endif

    CyBleHal_RadioInit();
    MTK_PutString("MTK+TWI FOR PSoC6A BLE-II\r\n");
    for(;;)
    {
        ProcessMTKCommands();   
        Process2WireCommands();
        ProcessRegulatoryTestTrigger();
    } 
}

/*******************************************************************************
* Function Name: _write
*******************************************************************************/
#if defined (__GNUC__)
    /* Add an explicit reference to the floating point printf library to allow
    the usage of floating point conversion specifier. */
    asm (".global _printf_float");
    /* For GCC compiler revise _write() function for printf functionality */
    int _write(int file, char *ptr, int len)
    {
        int nChars = 0;

        /* Suppress compiler warning about unused variable. */
        if (0 != file)
        {
        }
        
        for (/* Empty */; len != 0; --len)
        {
            /* Block until there is place in TX FIFO or buffer. */
            while (0UL == MTK_Put(*ptr))
            {
            }
            
            ++nChars;
            ++ptr;
        }
        
        return (nChars);
    }

#endif /* (__GNUC__) */
/* [] END OF FILE */
