/******************************************************************************

  Copyright (C), 2006-2015, Maxscend Co., Ltd.

 ******************************************************************************
  File Name     : mxd_betacy_sdk.h
  Version       : Initial Draft
  Author        : maxscend\yanping.wang
  Created       : 2015/12/5
  Last Modified :
  Description   : betacy sdk.h
  Function List :
  History       :
  1.Date        : 2015/12/5
    Author      : maxscend\yanping.wang
    Modification: Created file

******************************************************************************/

#ifndef _BETACY_SDK_H_
#define _BETACY_SDK_H_

#ifdef __cplusplus
extern "C"{
#endif
#include "cy_ble_stack.h"
#ifndef __USE_32BIT_PROCESSOR__
#define __USE_32BIT_PROCESSOR__
typedef unsigned char MXD_U8, *PMXD_U8;
typedef unsigned short MXD_U16, *PMXD_U16;
typedef unsigned int MXD_U32, *PMXD_U32;
typedef signed char MXD_S8, *PMXD_S8;
typedef signed short MXD_S16, *PMXD_S16;
typedef signed int MXD_S32, *PMXD_S32;
typedef signed char MXD_BOOL;
typedef char MXD_CHAR;
#endif

#ifdef MXDSDKDLL_EXPORTS	
#define MXD_API_C  __declspec(dllexport)
#else
#define MXD_API_C
#endif


void betacyRetentionInit(void);
extern void  betacyModeInit(void);
extern void betacyLoLock(MXD_U16 trx, MXD_U16 freqMHz);
extern void betacyDcocCali(void);
extern void betacyModemInit(void);
extern void betacyFdPoutInit(MXD_U8 persistRadioCal, cy_stc_ble_mxd_pa_cal_param_t paCalConfig);
extern void MxdRfInit(MXD_U8 persistRadioCal, cy_stc_ble_mxd_pa_cal_param_t paCalConfig);
extern MXD_U16 regBitsGet(MXD_U16 regAddr,MXD_U8 bitH, MXD_U8 bitL);
extern void rf_reg_read(MXD_U16 regAddr, MXD_U16 * pRegVal);
extern void rf_reg_write(MXD_U16 regAddr, MXD_U16 regVal);
extern void betacySetMode(MXD_U8 trx);

#if 0

#endif

// Bit Set
#define _BS(a,b)  (a) = (a) | (1<<(b))
// Bit Clear
#define _BC(a,b)  (a) = (a) & ( ~(1<<(b)) )
// BitS Clear
#define _BSC(x,hb,lb) (x) =  (x) &  (  ~( (2<<(hb))-(1<<(lb)) )  )

// Bits Get
#define _BSG(x,hb,lb) ( (   (x)&( ((2<<(hb)) -(1<<(lb) )    )  ))           >>(lb))
// BitS Set
#define _BSS(x,hb,lb,val)  _BSC(x,hb,lb);\
    (x) = (x) | (  ( (2<<(hb))-(1<<(lb)) ) & ((val&((1<<(hb-lb+1))-1))<<(lb))  )
#define _REGBS(reg,bn)      \
    do{ \
    MXD_U32 regVal = 0; \
    rf_reg_read( reg,  (MXD_U16 *) &regVal ); \
    _BS(regVal,bn); \
    rf_reg_write(reg, regVal ); \
    /* mxdDbgInfo("[mxd] ::  _REGBS [%x,%x] \r\n",reg,regVal); */\
    }while(0)

// RF_REG Bit clean
#define _REGBC(reg,bn)      \
    do{ \
    MXD_U32 regVal = 0; \
    rf_reg_read( reg,  (MXD_U16 *)&regVal ); \
    _BC(regVal,bn); \
    rf_reg_write(reg, regVal ); \
    /*mxdDbgInfo("[mxd] ::  _REGBC [%x,%x] \r\n",reg,regVal); */ \
    }while(0)

// RF_REG Bits set
#define _REGBSS(reg_x,hb,lb,val) \
    do{ \
    MXD_U32 regVal = 0; \
    rf_reg_read( reg_x,  (MXD_U16 *)&regVal ); \
    _BSS(regVal,hb,lb,val); \
    rf_reg_write(reg_x, regVal ); \
    }while(0)

#define _REG_CHK(reg,bitn) \
{\
    MXD_U32 regVal = 0; \
    do{ \
    rf_reg_read( reg,  &regVal ); \
    }while(0==(regVal&(1<<bitn)));\
}
#define _REG_CHK2(reg,bitn) \
{\
    MXD_U32 regVal = 0; \
    MXD_U32 maxCheck = 0;\
    do{ maxCheck++;\
    rf_reg_read( reg,  (MXD_U16 *)&regVal ); \
    }while(0==(regVal&(1<<bitn)));\
    if(maxCheck>500) mxdDbgInfo("[mxd] [%s]_REG_CHK2[%x].bit%d check=%d \r\n",__FUNCTION__,regVal,bitn, maxCheck);\
}
#define _REG_CHANGE(reg,val) \
{\
    MXD_U32 regVal = 0, tmp=val;\
	rf_reg_read( reg,  &regVal ); \
	rf_reg_write( reg,  val ); \
    mxdDbgInfo("[mxd] _REG_CHK2[%x] =0x%04x -> %04x\r\n",reg,regVal,tmp );\
}

#ifdef __cplusplus
   }
#endif

#endif /*_BETACY_SDK_H_*/
